summaryrefslogtreecommitdiffstats
path: root/package/mac80211/files
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2009-10-11 01:01:12 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2009-10-11 01:01:12 +0000
commitdd47052c85d71221e59bdb63c498226fba26717e (patch)
tree98594d69eeb5fc23a49db9f3b0f8319600099175 /package/mac80211/files
parent994c1fce91dfa45bc0aea43d77d83566dc9acc1b (diff)
mac80211: fix autochannel / fixed channel selection, add commands for unencrypted sta mode
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@18024 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/mac80211/files')
-rw-r--r--package/mac80211/files/lib/wifi/mac80211.sh21
1 files changed, 14 insertions, 7 deletions
diff --git a/package/mac80211/files/lib/wifi/mac80211.sh b/package/mac80211/files/lib/wifi/mac80211.sh
index 1a8272aca..c11da4279 100644
--- a/package/mac80211/files/lib/wifi/mac80211.sh
+++ b/package/mac80211/files/lib/wifi/mac80211.sh
@@ -68,8 +68,8 @@ disable_mac80211() (
)
get_freq() {
local phy="$1"
- local channel="$2"
- iw "$phy" info | grep -E -m1 "(\* ${channel:-....} MHz${channel:+|\\[$channel\\]})" | grep MHz | awk '{print $2}'
+ local chan="$2"
+ iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep MHz | awk '{print $2}'
}
enable_mac80211() {
local device="$1"
@@ -79,9 +79,15 @@ enable_mac80211() {
find_mac80211_phy "$device" || return 0
config_get phy "$device" phy
local i=0
+ fixed=""
+ [ "$channel" = "auto" -o "$channel" = "0" ] || {
+ fixed=1
+ }
+
+ export channel fixed
# convert channel to frequency
- local freq="$(get_freq "$phy" "$channel")"
+ local freq="$(get_freq "$phy" "${fixed:+$channel}")"
wifi_fixup_hwmode "$device" "g"
for vif in $vifs; do
@@ -141,7 +147,7 @@ enable_mac80211() {
# We attempt to set teh channel for all interfaces, although
# mac80211 may not support it or the driver might not yet
- [ -z "$channel" ] || iw dev "$ifname" set channel "$channel"
+ [ -n "$fixed" ] && iw dev "$ifname" set channel "$channel"
local key keystring
@@ -222,12 +228,13 @@ enable_mac80211() {
;;
adhoc)
config_get bssid "$vif" bssid
- iw dev "$ifname" ibss join "$ssid" ${freq:+$freq fixed-freq} $bssid
+ iw dev "$ifname" ibss join "$ssid" $freq ${fixed:+fixed-freq} $bssid
;;
sta|mesh)
- # Fixup... sometimes you have to scan to get beaconing going
- iw dev "$ifname" scan &> /dev/null
case "$enc" in
+ *)
+ iw dev "$ifname" connect "$ssid"
+ ;;
wep)
if [ -e "$keymgmt" ]; then
[ -n "$keystring" ] &&